/**
 * @file
 * Written by Henri MEDOT <henri.medot[AT]absyx[DOT]fr>
 * http://www.absyx.fr
 *
 * Inspired by Resumable.js
 * http://resumablejs.com
 *
 * Released under the GPLv2 license.
 */

!function(e){"use strict";var t=function(e){var t,n,i,r=arguments,s=r.length;for(t=1;s>t;t++){n=r[t];for(i in n)e[i]=n[i]}return e},n=function(e,t){for(var n=0,i=e.length;i>n&&t(e[n])!==!1;n++);},i=function(e,t){for(var n=0,i=t.length;i>n;n++)if(t[n]===e)return n;return-1},r=function(e,t,n){e.addEventListener(t,n,!1)},s=function(e){e.preventDefault()},a=function(){return(new Date).getTime()},u=function(e,t){var r=e.options,s=r.maxFiles,a=e.files,u=a.length,l=[];n(t,function(t){var n=l.length;if(1==s&&n||s>1&&u+n==s)return!1;var a=new C(e,t);if(!e.getFileById(a.id)){var o,f=a.size,p=r.maxFileSize;if(!f||p&&f>p)o="size";else{var d=r.extensions;d&&i(a.extension,d)<0&&(o="extension")}if(o)h(e,"resupaddedfileerror",[a,o]);else{var c=r.fileValidator;(!c||c(a))&&l.push(a)}}});var f=l.length;if(f){if(1==s&&u){var p=e.uploading;e.stop(),e.removeFile(a[0]),e.uploading=p}e.files=a.concat(l),o(e)}h(e,"resupfilesadded",[l,t.length-f])},o=function(e){if(e.uploading){p(e);var t=e.queue=[],i=0,r=e.options.maxRequests;if(n(e.files,function(e){e.xhr?i++:t.push(e)}),i||t.length)for(;r>i&&t.length;)d(t.shift()),i++;else f(e)}},l=function(t){var n=t.r;if(n.uploading){p(n);var i=n.queue;if(1&t.status){if(t.retries>=4)return t.status=8,h(n,"resupfileerror",[t]),o(n),e;i.push(t)}var r=i.shift();if(r)d(r);else{var s,a=n.files,u=a.length;for(s=0;u>s;s++)if(a[s].xhr)return;f(n)}}},f=function(e){e.uploading=!1;var t=[],i=[];n(e.files,function(e){(4==e.status?t:i).push(e)}),h(e,"resupended",[t,i])},p=function(e){h(e,"resupprogress")},d=function(n){var i=n.status;if(12&i)return l(n),e;var s,u=n.r,o=u.options,f=u.url,d=t({},o.query,{resup_file_id:n.id}),c=new XMLHttpRequest;switch(r(c,"loadstart",function(){n.xhrp=0,n.xhr=c}),r(c,"loadend",function(){if(n.xhr=null,200!=c.status)n.sa||(n.retries++,l(n));else{var e=c.responseText;/^\d+$/.test(e)?(e=+e,3==n.status&&(n.retries=e==n.uploadedChunks+1?0:n.retries+1),n.uploadedChunks=e,n.status=e==n.totalChunks?4:3):(n.retries++,n.status=1),l(n)}}),i){case 0:n.status=1;case 1:t(d,{resup_file_name:n.name,resup_file_size:n.size});var h=[];for(s in d)h.push(s+"="+encodeURIComponent(d[s]));c.open("GET",f+(f.indexOf("?")<0?"?":"&")+h.join("&")+"&_"+a()),c.timeout=1e4,c.send();break;case 3:r(c,"progress",function(e){e.lengthComputable&&(n.xhrp=e.loaded/e.total,p(u))});var v=n.uploadedChunks,g=o.chunkSize,m=v*g,x=new FormData;t(d,{resup_file_id:n.id,resup_chunk_number:v+1});for(s in d)x.append(s,d[s]);x.append(o.inputName,n._file.slice(m,v<n.totalChunks-1?m+g:n.size)),c.open("POST",f),c.timeout=6e4,c.send(x)}},c=function(e){var t=e.xhr;t&&(e.sa=!0,t.abort(),e.sa=!1,e.xhr=null)},h=function(e,t,n){var i=e["on"+t];i&&i.apply(e,n)},v=window.Resup=function(e,n){var i=this,a=i.options=t({inputName:"resup_chunk",chunkSize:1048576,maxRequests:3,query:{}},n||{}),o=a.drop,l=a.maxFiles,f=i.input=document.createElement("input");f.type="file",f.multiple=null==l||l>1,r(f,"change",function(){u(i,f.files),f.value=""}),i.url=e,i.files=[],o&&(r(o,"dragover",s),r(o,"drop",function(e){u(i,e.dataTransfer.files),s(e)}))},g=typeof e,m=typeof File!==g&&typeof FileList!==g&&typeof FormData!==g;if(m){var x=File.prototype,k=x.webkitSlice||x.mozSlice||x.slice;m=!!k,x.slice=k}v.support=m;var z=v.prototype;z.upload=function(){var e=this;!e.uploading&&e.files.length&&(e.uploading=!0,o(e))},z.retry=function(){var e,t=this;n(t.files,function(t){t.retries=0,8==t.status&&(t.status=0,e=!0)}),e&&o(t),t.upload()},z.stop=function(){var e=this;e.uploading&&(e.uploading=!1,n(e.files,c))},z.removeFile=function(e){var t=this,n=t.files,r=i(e,n);r>-1&&(c(e),n.splice(r,1),o(t))},z.getFileById=function(e){var t,n,i=this.files,r=i.length;for(t=0;r>t;t++)if(n=i[t],n.id==e)return n},z.getProgress=function(){var e=0,t=0;return n(this.files,function(n){if(n.status<8){e+=n.totalChunks,t+=n.uploadedChunks;var i=n.xhrp;n.xhr&&i&&(t+=i)}}),e?t/e:0};var C=function(e,t){var n=this;n.r=e,n._file=t,n.name=t.fileName||t.name,n.size=t.fileSize||t.size,n.date=t.lastModifiedDate,n.uploadedChunks=0,n.status=0,n.retries=0;var i=n.name.split("."),r=i.length;n.extension=r>1?i[r-1].toLowerCase():"";var s=0,u=n.date;if(u instanceof Date){var s=u.getTime();a()-s<1e3&&(s=0)}n.id=[n.size,s,encodeURIComponent(n.name).replace(/[^\w%]/g,function(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()})].join("-"),n.totalChunks=Math.ceil(n.size/e.options.chunkSize)}}();